#ifndef _KGR_PATCH_BSC1080338_H
#define _KGR_PATCH_BSC1080338_H

#if IS_ENABLED(CONFIG_X86_64)

int kgr_patch_bsc1090338_init(void);
void kgr_patch_bsc1090338_cleanup(void);


struct task_struct;
struct pt_regs;

int kgr_arch_dup_task_struct(struct task_struct *dst, struct task_struct *src);
void kgr_flush_thread(void);
void kgr_do_signal(struct pt_regs *regs);
int kgr__restore_xstate_sig(void __user *buf, void __user *buf_fx, int size);
void kgr__kernel_fpu_end(void);

#define KGR_PATCH_BSC1090338_FUNCS					\
	KGR_PATCH(arch_dup_task_struct, kgr_arch_dup_task_struct),	\
	KGR_PATCH(flush_thread, kgr_flush_thread),			\
	KGR_PATCH(do_signal, kgr_do_signal),				\
	KGR_PATCH(__restore_xstate_sig, kgr__restore_xstate_sig),	\
	KGR_PATCH(__kernel_fpu_end, kgr__kernel_fpu_end),	\


#else /* !IS_ENABLED(CONFIG_X86_64) */

static inline int kgr_patch_bsc1090338_init(void) { return 0; }
static inline void kgr_patch_bsc1090338_cleanup(void) {}

#define KGR_PATCH_BSC1090338_FUNCS

#endif /* IS_ENABLED(CONFIG_X86_64) */

#endif
